"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ui_1 = require("@teambit/ui");
const react_1 = __importStar(require("react"));
const uuid_1 = require("uuid");
const notifications_notification_context_1 = require("@teambit/notifications.notification-context");
const notifications_notification_center_1 = require("@teambit/notifications.notification-center");
const notifications_api_1 = require("@teambit/notifications.api");
const notification_reducer_1 = require("./notification-reducer");
const notifications_aspect_1 = require("./notifications.aspect");
class NotificationUI {
    constructor(uiRuntimeExtension) {
        this.add = (message, level) => {
            var _a;
            const id = uuid_1.v1();
            (_a = this.dispatch) === null || _a === void 0 ? void 0 : _a.call(this, {
                type: 'add',
                content: {
                    id,
                    message,
                    level,
                    time: new Date().toISOString(),
                },
            });
            return id;
        };
        this.log = (message) => this.add(message, notifications_api_1.MessageLevel.info);
        this.warn = (message) => this.add(message, notifications_api_1.MessageLevel.warning);
        this.error = (message) => this.add(message, notifications_api_1.MessageLevel.error);
        this.success = (message) => this.add(message, notifications_api_1.MessageLevel.success);
        this.clear = () => {
            var _a;
            (_a = this.dispatch) === null || _a === void 0 ? void 0 : _a.call(this, {
                type: 'clear',
            });
        };
        this.render = (props) => {
            const [messages, dispatch] = react_1.useReducer(notification_reducer_1.notificationReducer, []);
            this.dispatch = dispatch;
            return react_1.default.createElement(notifications_notification_center_1.NotificationCenter, Object.assign({}, props, { notifications: messages }));
        };
        this.renderContext = ({ children }) => {
            return react_1.default.createElement(notifications_notification_context_1.NotificationContext.Provider, { value: this }, children);
        };
        uiRuntimeExtension.registerHudItem(react_1.default.createElement(this.render, { key: "NotificationUI" }));
        uiRuntimeExtension.registerContext(this.renderContext);
    }
    static provider([uiRuntimeExtension]) {
        return __awaiter(this, void 0, void 0, function* () {
            return new NotificationUI(uiRuntimeExtension);
        });
    }
    dismiss(id) {
        var _a;
        (_a = this.dispatch) === null || _a === void 0 ? void 0 : _a.call(this, {
            type: 'dismiss',
            id,
        });
    }
}
exports.default = NotificationUI;
NotificationUI.dependencies = [ui_1.UIAspect];
NotificationUI.runtime = ui_1.UIRuntime;
notifications_aspect_1.NotificationsAspect.addRuntime(NotificationUI);
//# sourceMappingURL=notification.ui.runtime.js.map